#ifndef _QCHANNELWIDGET_H_
#define _QCHANNELWIDGET_H_

#include <QtGui>

#include "ui_qchannelwidget.h"

namespace projection
{
class Channel;

class QChannelWidget : public QWidget
{
    Q_OBJECT

public:

    QChannelWidget(QWidget* pParent=0, Qt::WFlags flag=0);
    ~QChannelWidget();

    void setChannel(Channel* pChannel);
    Channel* getChannel() const;

public slots:

    void updateGUI();

private slots:

    void on_nameEdit_editingFinished();
    void on_overlayNameCheckBox_toggled(bool checked);
    void on_remoteHostNameEdit_editingFinished();
    void on_remoteFullScreenCheckBox_toggled(bool checked);
    void on_remoteScreenComboBox_activated(int index);
    void on_overlayImageEdit_editingFinished();
    void on_overlayImageBrowseButton_clicked();
    void on_warpCheckBox_toggled(bool checked);
    void on_warpResSpinBox_valueChanged(int value);
    void on_warpResetButton_clicked();
    void on_calibrateButton_clicked();
    void on_fitButton_clicked();
    void on_windowButton_clicked();

private:

    Ui::QChannelWidget ui;

    Channel* m_pChannel;
};

}; // projection

#endif // _QCHANNELWIDGET_H_
