#ifndef _QFRUSTUMWIDGET_H_
#define _QFRUSTUMWIDGET_H_

#include <QtGui>

#include "Frustum.h"

#include "ui_qfrustumwidget.h"

namespace projection
{

class QFrustumWidget : public QWidget
{
    Q_OBJECT

public:

    QFrustumWidget(QWidget* pParent=0, Qt::WFlags flag=0);
    ~QFrustumWidget();

    void setFrustum(Frustum* pFrustum);
    void clear();

public slots:

    void updateGUI();

private slots:

    void on_projectionWidget_matrixChanged(const ProjectionMatrix& matrix);
    void on_transformWidget_matrixChanged(const TransformMatrix& matrix);

private:

    Ui::QFrustumWidget ui;

    Frustum* m_pFrustum;
};

}; // projection

#endif // _QFRUSTUMWIDGET_H_
