#ifndef _QPREFERENCEDIALOG_H_
#define _QPREFERENCEDIALOG_H_

#include <QtGui>

#include "ui_qpreferencedialog.h"

namespace projection
{
class ProjectionModel;
class QDesignViewWidget;

class QPreferenceDialog : public QDialog
{
    Q_OBJECT

public:

    QPreferenceDialog(QWidget* pParent=0, Qt::WFlags flag=0);
    ~QPreferenceDialog();

    void setModel(ProjectionModel* pModel);

    void updateGUI();

private slots:

    void on_gridSizeEdit_editingFinished();
    void on_gridSubdivSpinBox_valueChanged(int value);

    void on_bufferTypeComboBox_activated(int);
    void on_bufferWidthComboBox_activated(int);
    void on_bufferHeightComboBox_activated(int);

	void on_exportWidthComboBox_activated(int);
	void on_exportHeightComboBox_activated(int);
    void on_softEdgeCheckBox_toggled(bool checked);
    void on_blendEdgeWidthSpinBox_valueChanged(int value);
    void on_blendEdgeExponentEdit_editingFinished();
    void on_exportDistortMapPatternEdit_editingFinished();
    void on_exportBlendMapPatternEdit_editingFinished();
    void on_exportViewMatrixPatternEdit_editingFinished();

private:

    Ui::QPreferenceDialog ui;
    QDesignViewWidget* m_pDesignView;

    ProjectionModel* m_pModel;
};

}; // projection

#endif // _QPREFERENCEDIALOG_H_
