#ifndef _QSCENEWIDGET_H_
#define _QSCENEWIDGET_H_

#include <QtGui>

#include "ui_qscenewidget.h"

namespace projection
{
class Scene;

class QSceneWidget : public QWidget
{
    Q_OBJECT

public:

    QSceneWidget(QWidget* pParent=0, Qt::WFlags flag=0);
    ~QSceneWidget();

    void setScene(Scene* pScene);

    void updateGUI();

private slots:

    void on_transformWidget_matrixChanged(const TransformMatrix& matrix);
    void on_typeComboBox_activated(int);

    void on_frontFileNameEdit_editingFinished();
    void on_frontBrowseButton_clicked();
    void on_backFileNameEdit_editingFinished();
    void on_backBrowseButton_clicked();
    void on_leftFileNameEdit_editingFinished();
    void on_leftBrowseButton_clicked();
    void on_rightFileNameEdit_editingFinished();
    void on_rightBrowseButton_clicked();
    void on_topFileNameEdit_editingFinished();
    void on_topBrowseButton_clicked();
    void on_bottomFileNameEdit_editingFinished();
    void on_bottomBrowseButton_clicked();

    void on_modelFileNameEdit_editingFinished();
    void on_modelBrowseButton_clicked();
    void on_modelCullingCheckBox_toggled(bool checked);
    void on_modelSmoothingCheckBox_toggled(bool checked);

    void on_showInDesignViewCheckBox_toggled(bool checked);
    void on_sceneSizeEdit_editingFinished();
    void on_frameCheckBox_toggled(bool checked);
    void on_gridCheckBox_toggled(bool checked);
    void on_gridSizeEdit_editingFinished();

    void on_resetCameraButton_clicked();

private:

    Ui::QSceneWidget ui;

    Scene* m_pScene;
};

}; // projection

#endif // _QSCENEWIDGET_H_
