#include "scene/SceneEmpty.h"

using namespace projection;

/**
 * Constructor.
 *
 * @param pScene Scene data.
 */
SceneEmpty::SceneEmpty(Scene* pScene) : SceneContent(pScene)
{
}

/**
 * Destructor.
 */
SceneEmpty::~SceneEmpty()
{
}

/**
 * Initialize screen content. 
 */
void SceneEmpty::init()
{
}

/**
 * Draw the scene content.
 *
 * @param cameraFrame View point data.
 */
void SceneEmpty::draw(const qglviewer::Frame&)
{
}

/**
 * Retrieve bounding box of the scene content.
 *
 * @param min One corner of the scene content.
 * @param max Another corner of the scene content.
 */
void SceneEmpty::getBoundingBox(qglviewer::Vec& min, qglviewer::Vec& max)
{
    min.setValue(-0.5f, -0.5f, -0.5f);
    max.setValue( 0.5f,  0.5f,  0.5f);
}

/**
 * Restore the scene content from XML data.
 *
 * @param element Parent XML element of the scene content data.
 */
void SceneEmpty::initFromDOMElement(const QDomElement& element)
{
    if (!element.isNull())
    {
    }
}

/**
 * Store the current scene content as XML data.
 *
 * @param name XML node name of the data.
 * @param doc XML document to store the data.
 * @return Current scene content data as XML data.
 */
QDomElement SceneEmpty::domElement(const QString& name, QDomDocument& doc) const
{
    QDomElement de = doc.createElement(name);
    return de;
}
