#include <stdio.h>
#include <stdlib.h>
#include <glut.h>

#include "Scene.h"
#include "scene/SceneTeapot.h"

using namespace projection;

/**
 * Constructor.
 *
 * @param pScene Scene data.
 */
SceneTeapot::SceneTeapot(Scene* pScene) : SceneContent(pScene)
{
}

/**
 * Destructor.
 */
SceneTeapot::~SceneTeapot()
{
}

/**
 * Initialize screen content.
 */
void SceneTeapot::init()
{
}

/**
 * Draw the scene content.
 *
 * @param cameraFrame View point data.
 */
void SceneTeapot::draw(const qglviewer::Frame&)
{
    glPushAttrib(GL_ENABLE_BIT);
    glDisable(GL_TEXTURE_2D);
	glPushMatrix();
    if (!m_pScene->getShowFrame())
    	glutSolidTeapot(0.25);
    else
    	glutWireTeapot(0.25);
    glPopMatrix();
    glPopAttrib();
}

/**
 * Retrieve bounding box of the scene content.
 *
 * @param min One corner of the scene content.
 * @param max Another corner of the scene content.
 */
void SceneTeapot::getBoundingBox(qglviewer::Vec& min, qglviewer::Vec& max)
{
    min.setValue(-0.5f, -0.5f, -0.5f);
    max.setValue( 0.5f,  0.5f,  0.5f);
}

/**
 * Restore the scene content from XML data.
 *
 * @param element Parent XML element of the scene content data.
 */
void SceneTeapot::initFromDOMElement(const QDomElement& element)
{
    if (!element.isNull())
    {
    }
}

/**
 * Store the current scene content as XML data.
 *
 * @param name XML node name of the data.
 * @param doc XML document to store the data.
 * @return Current scene content data as XML data.
 */
QDomElement SceneTeapot::domElement(const QString& name, QDomDocument& doc) const
{
    QDomElement de = doc.createElement(name);
    return de;
}
